

//+------------------------------------------------------------------+
//|                                              GoldenFilter_v1.mq4 |
//|                                         Copyright  2007, madro  |
//|                                               madrofx@yahoo.com  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, madro"
#property  link      "madrofx@yahoo.com"
//----
#property indicator_separate_window    
#property indicator_buffers 8
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_color1  Lime
#property indicator_color2  Red
#property indicator_color3  Lime
#property indicator_color4  Red
#property indicator_color5  Lime
#property indicator_color6  Red
#property indicator_color7  Lime
#property indicator_color8  Red
#property indicator_width7  2
#property indicator_width8  2

//
//
//
//
//

extern int    FastMa          = 7;
extern int    FastMAMethod    = MODE_LWMA;
extern int    FastMAPrice     = PRICE_CLOSE;
extern int    SlowMa          = 40;
extern int    SlowMAMethod    = MODE_LWMA;
extern int    SlowMAPrice     = PRICE_CLOSE;
extern int    MACD_Fast       = 12;
extern int    MACD_Slow       = 26;
extern int    MACD_Signal     = 9; 
extern int    RSI             = 13;
extern int    Momentum        = 13;
extern int    DeMarker        = 13;
extern int    ADX             = 13;
extern int    ForceIndex      = 13;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double Up[];
double Dn[];
double CrossUp[];
double CrossDn[];
double TrendUp[];
double TrendDn[];
double MAUp[];
double MADn[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   
   SetIndexBuffer(0,Up);      SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,120);
   SetIndexBuffer(1,Dn);      SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,120);
   SetIndexBuffer(2,CrossUp); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,251);
   SetIndexBuffer(3,CrossDn); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,251);
   SetIndexBuffer(4,TrendUp); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,110);
   SetIndexBuffer(5,TrendDn); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,110);
   SetIndexBuffer(6,MAUp);    SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,241);
   SetIndexBuffer(7,MADn);    SetIndexStyle(7,DRAW_ARROW); SetIndexArrow(7,242);

   IndicatorShortName("madro-9");
return(0);
}

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit()  {   return(0);  }

//
//
//+------------------------------------------------------------------+
//|  GoldenFilter_v1                                                 |
//+------------------------------------------------------------------+

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
   if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars); 
   
      double fastMA = iMA(NULL,0,FastMa,0,FastMAMethod,FastMAPrice,i);
      double slowMA = iMA(NULL,0,SlowMa,0,SlowMAMethod,SlowMAPrice,i);
        
      double  MACD     = iMACD(Symbol(),Period(),MACD_Fast,MACD_Slow,MACD_Signal,PRICE_CLOSE,MODE_MAIN,  i);                    
      double  MACD_Sig = iMACD(Symbol(),Period(),MACD_Fast,MACD_Slow,MACD_Signal,PRICE_CLOSE,MODE_SIGNAL,i);
                               
      double  ADX1 = iADX(NULL,0,ADX,PRICE_CLOSE, MODE_PLUSDI, i);
      double  ADX2 = iADX(NULL,0,ADX,PRICE_CLOSE, MODE_MINUSDI,i);
      double  RSIV = iRSI(NULL,0,RSI,0, i);
      double  DEM  = iDeMarker(NULL, 0, DeMarker, i); 
      double  MOM  = iMomentum( NULL,0, Momentum, PRICE_CLOSE, i); 
      double  FI   = iForce(NULL,0, ForceIndex, 1, PRICE_CLOSE,i);
      
      //
      //
      //
      //
      //
      
	 	if(MOM >  100) Up[i] = 0.05;     
      if(MOM <= 100) Dn[i] = 0.05; 
           
      if(DEM > 0.5 && FI > 0) TrendUp[i] = 0.22;    
      if(DEM < 0.5 && FI < 0) TrendDn[i] = 0.22; 
                   
      if(RSIV > 50 && MACD > MACD_Sig && ADX1 > ADX2) CrossUp[i] = 0.47;     
      if(RSIV < 50 && MACD < MACD_Sig && ADX1 < ADX2) CrossDn[i] = 0.47;
       
      trend[r] = trend[r-1]; 
      if (fastMA > slowMA) trend[r] = 1;
      if (fastMA < slowMA) trend[r] =-1;   
      
      //
      //
      //
      //
      //
      
      MAUp[i] = EMPTY_VALUE;
      MADn[i] = EMPTY_VALUE;
      if (trend[r] != trend[r-1])
      if (trend[r] == 1)
            MAUp[i]  = 0.8;
      else  MADn[i]  = 0.8;
      }
         
      if (alertsOn)
      {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,0,whichBar)); whichBar = Bars-whichBar-1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar-1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}

//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Madro Golden trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Madro Golden "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}



